//SOURCES + MEMO
// carte mfrc522 : https://www.electronique-mixte.fr/microcontrolleurs/mfrc522-controle-dacces-par-badge-avec-arduino/
// ecran LCD 4 fils avec module I2C https://icn.lycee-valin.fr/dokuwiki/doku.php?id=arduino:utiliser_un_ecran_lcd
// HP + 220 sur port 8 

#include "pitches.h"
#include <SPI.h> // SPI
#include <MFRC522.h> // mfrc522
#include <LiquidCrystal_I2C.h>   // inclure la bibliothèque I2C
LiquidCrystal_I2C lcd(0x27,16,2);   // adresse i2c , nombre de colonnes, nombre de lignes de l'écran

#define SS_PIN 10
#define RST_PIN 9

// Déclaration 
MFRC522 mfrc522(SS_PIN, RST_PIN); 

// Tableau contenant l'ID
byte nuidPICC[4];
MFRC522::MIFARE_Key key;

// variables
int melody[] = {
  NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_G3, 0, NOTE_B3, NOTE_C4
};
int noteDurations[] = {
  4, 8, 8, 4, 4, 4, 4, 4
};
int HP = 8;
int maxim = 10; // A MODIFIER SELON NOMBRE DE CARTES A VALIDER
String cartes[15]={};
String lacarte ="ID";
String lader="";
int verif=0;
String secteur4=""; 
//String msgdecompte="CARTE";

void setup() 
{ 
  // Init RS232
  Serial.begin(9600);

  // Init SPI bus
  SPI.begin(); 
  // Init MFRC522 
  mfrc522.PCD_Init(); 
  lcd.init();   // initialisation du LCD
  lcd.backlight();

  // Prepare the key (used both as key A and as key B)
  // using FFFFFFFFFFFFh which is the default at chip delivery from the factory
    for (byte i = 0; i < 6; i++) {
        key.keyByte[i] = 0xFF;
    }
  
  // Print a message to the LCD.
  lcd.setCursor(0, 0);
  lcd.print("INITIALISATION");
  lcd.setCursor(0, 1);
  lcd.print("NB DE CARTES: "); lcd.print(maxim);
  // iterate over the notes of the melody:
  for (int thisNote = 0; thisNote < 8; thisNote++) {

    // to calculate the note duration, take one second divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000 / noteDurations[thisNote];
    tone(8, melody[thisNote], noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(8);
  }
  delay(2000);
  lcd.clear();
  lcd.noBacklight();
}
 
void loop() 
{

  // Initialisé la boucle si aucun badge n'est présent 
  if ( !mfrc522.PICC_IsNewCardPresent())
    return;

  // Vérifier la présence d'un nouveau badge 
  if ( !mfrc522.PICC_ReadCardSerial())
    return;

  // RECUPERATION ID DU BADGE (4 octects) 
  lacarte="ID";
  for (byte i = 0; i < 4; i++) 
  {
    nuidPICC[i] = mfrc522.uid.uidByte[i];
    lacarte.concat(nuidPICC[i]);
  }


// LECTURE DATAS SECTEUR1/BLOCK4 DE LA CARTE - sector #1, covering block #4 
    byte sector         = 1;
    byte blockAddr      = 4;
    byte buffer[18];
    byte size = sizeof(buffer);
  
  mfrc522.PICC_DumpMifareClassicSectorToSerial(&(mfrc522.uid), &key, sector);
  dump_byte_array(buffer, 5);
    //SI CARTE DE CONFIGURATION :  +1 carte à valider jusqu'à 14
    if (secteur4=="SCAPE")
  {
  maxim++;
  if(maxim>14){maxim=1; reinitialise();}
  lcd.backlight();
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("NB DE CARTES :");
  lcd.setCursor(0, 1);
  lcd.print(maxim);
  tone(HP,2000,400);
  delay(500);
  lcd.clear();
  lcd.noBacklight();
  } 
// SINON
else
{
  // Test si carte déja présentée
 for (int i = 0; i < maxim; i++)
    {
        // si fin de la liste la carte est ajoutée
        if (cartes[i]=="") {

          if (i==(maxim-1)){
            int a=i+1;
            Serial.print("CARTE ");Serial.print(a);Serial.print("/");Serial.println(maxim);
          Serial.println("BIENVENUE !");
          delay(500);
            Serial.println("VOTRE NOUVELLE DESTINATION ");
             Serial.println("DROIDLAND");
       tone(HP,240,300);
  delay(300);
  tone(HP,440,400);
    lcd.backlight();
    lcd.clear();
        lcd.setCursor(0, 0);
  lcd.print("CARTE ");lcd.print(a);lcd.print("/");lcd.print(maxim);
  lcd.setCursor(0, 1);
  lcd.print("BIENVENUE !");
  delay(900);
  lcd.clear();
lcd.setCursor(0, 0);
  lcd.print("DESTINATION :");
  lcd.setCursor(0, 1);
  lcd.print("DROIDLAND");
  delay(10000);
  lcd.clear();
  lcd.noBacklight();
             
            reinitialise();
            break;
          }
  else
  {
          
        cartes[i]=lacarte;
        lader=lacarte; 
        int a=i+1;
        Serial.print("CARTE ");Serial.print(a);Serial.print("/");Serial.println(maxim);
        Serial.println("BIENVENUE !");
  tone(HP,240,300);
  delay(300);
  tone(HP,440,400);
  lcd.backlight();
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("CARTE ");lcd.print(a);lcd.print("/");lcd.print(maxim);
  lcd.setCursor(0, 1);
  lcd.print("BIENVENUE !");
  delay(900);
  lcd.clear();
  lcd.noBacklight();
        verif=0;
        break;
  } 
        }

        // si carte déjà vue
        if (lacarte==cartes[i]) {
        
          if ((verif==1)&&(lader==lacarte)){
           verif=2; 
           break;
          }
          else {
            verif=1;
            lader=lacarte;
            break;
          }
        
        
        }
    }

 if (verif==0){
  

 }
  if (verif==1){
   tone(HP,200,2000); 
   Serial.println("ATTENTION ! CARTE DEJA VALIDEE"); 
   lcd.backlight();
   lcd.clear();
    lcd.setCursor(0, 0);
  lcd.print("CARTE");
  lcd.setCursor(0, 1);
  lcd.print("DEJA VALIDEE");
  delay(900);
  lcd.clear();
  lcd.noBacklight();
  }

  if (verif==2){
   tone(HP,100,2000); 
   Serial.println("PHASE DE REINITIALISATION");
   lcd.backlight();
   lcd.setCursor(0, 0);
   lcd.clear();
  lcd.print("REINITIALISATION");
  lcd.setCursor(0, 1);
  lcd.print("EN COURS...");
  delay(900);
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("REINITIALISATION");
  lcd.setCursor(0, 1);
  lcd.print("NB DE CARTES: ");lcd.print(maxim);
  delay(900);
  lcd.noBacklight();
  lcd.clear();
    reinitialise();
  }


 // for (int i = 0; i <maxim; i++)
  //  {
 // Serial.println(verif);
 // Serial.println(cartes[i]);
 // }

 
}
  // Re-Init mfrc522
  mfrc522.PICC_HaltA(); // Halt PICC
  mfrc522.PCD_StopCrypto1(); // Stop encryption on PCD
}

void reinitialise(){
      for (int i = 0; i <maxim; i++)
    {
  cartes[i]="";
  }
    
    lacarte ="ID";
    lader="";
    verif=0;
  }
 void dump_byte_array(byte *buffer, byte bufferSize) {
  secteur4="";
    for (byte i = 0; i < bufferSize; i++) {
        Serial.print(buffer[i] < 0x10 ? " 0" : " ");
        Serial.print(buffer[i], HEX);
        char Lettre = buffer[i];
        secteur4.concat(Lettre);
    }
    Serial.println("");
    Serial.println(secteur4);

}
